from osv import osv,fields
from tools.translate import _
import time
from mx import DateTime
import datetime

class log_log(osv.osv):
    _name = 'log.log'
     
    _columns = {
        'name': fields.char('Action', size=64 ,readonly=1),
        'description':fields.text("Description"  ,readonly=1),
        'date': fields.datetime('Date',readonly=1),
        "object_id": fields.many2one('ir.model', 'Object' ,readonly=1),
        "user_id": fields.many2one('res.users', 'User',readonly=1),
        "res_id":fields.integer('Resource Id',readonly=1),
    }
    _defaults = {
        'date': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
        'user_id': lambda obj,cr,uid,ctx : uid,
    }
    _order = "date desc"
    
    def get_obj_name(self,cr,uid,model):
        obj_id = self.pool.get("ir.model").search(cr,uid,[('model','=',model)]) 
        if obj_id:
            return obj_id[0]
        else:
            return False
log_log()

class purchase_requirement(osv.osv):

    _inherit="purchase.requirement"

    def _get_log(self,cr,uid,ids,name,args,context={}):
        vals={}
        log_obj=self.pool.get("log.log")
        for req in self.browse(cr,uid,ids):
            lines = log_obj.search(cr,uid,[('object_id','=',log_obj.get_obj_name(cr,uid,'purchase.requirement')),('res_id','=',req.id)])
            vals[req.id]=lines
        return vals

    _columns={
                "log" : fields.text("Reason",help="specific reason to reject"),
                "logs" :fields.function(_get_log,method=True,type="one2many",relation="log.log",string="Action History"),     
    }

    def wkf_cancel(self,cr,uid,ids,context={}):
        """
            when cancel need to record reason
        """
        for req in self.browse(cr,uid,ids):
            if not req.log:
                raise osv.except_osv(_('Error!') ,_('You must give reason for cancelling'))
            else:
                obj_id = self.pool.get("log.log").get_obj_name(cr,uid,'purchase.requirement')
                self.pool.get("log.log").create(cr,uid,{'name':'Cancel','res_id':req.id,'description':req.log,'object_id':obj_id})
            req.write({"state":"cancelled",'log':False})
        return True

purchase_requirement()

class sale_order(osv.osv):
    _inherit="sale.order"

    def _get_log(self,cr,uid,ids,name,args,context={}):
        vals={}
        log_obj=self.pool.get("log.log")
        for req in self.browse(cr,uid,ids):
            lines = log_obj.search(cr,uid,[('object_id','=',log_obj.get_obj_name(cr,uid,'sale.order')),('res_id','=',req.id)])
            vals[req.id]=lines
        return vals

    _columns={
            "log" : fields.text("Reason",help="specific reason to reject"),
            "logs" :fields.function(_get_log,method=True,type="one2many",relation="log.log",string="Action History"),
    }

    def wkf_quote(self, cr, uid, ids, context=None):
        #print "ac log : wkf_quote"
        self.write(cr, uid, ids, {'state': 'quote', 'log':False})
        return True

    def button_disapprove(self, cr, uid, ids, *args):
        #print "ac log : wkf_disapprove"
        for req in self.browse(cr,uid,ids):
            if not req.log:
                raise osv.except_osv(_('Error!') ,_('You must give reason for disapprove'))
            else:
                obj_id = self.pool.get("log.log").get_obj_name(cr,uid,'sale.order')
                self.pool.get("log.log").create(cr,uid,{'name':'Disapprove','res_id':req.id,'description':req.log,'object_id':obj_id})
        return super(sale_order,self).button_disapprove(cr, uid, ids, args)

    def button_revise(self, cr, uid, ids, *args):
        for req in self.browse(cr,uid,ids):
            if not req.log:
                raise osv.except_osv(_('Error!') ,_('You must give reason for revise'))
            else:
                obj_id = self.pool.get("log.log").get_obj_name(cr,uid,'sale.order')
                self.pool.get("log.log").create(cr,uid,{'name':'Revise','res_id':req.id,'description':req.log,'object_id':obj_id})

        return super(sale_order,self).button_revise(cr, uid, ids, args)
sale_order()
